`gam.sig.start` <-
function(form,gam.data,pts,region,h,ngrid)
{
################ Tolerance interval for GAM ####################


# Let  gam.data    be original data used for doing gamfit
# Let  fitted.gam  be the result of doing a gamfit 
# Let  h	   be chosen smoothing parameter
# sets things up for doing signicance...
        formul=formula(form)
        termos<-terms(formul)
        at<-as.character(attr(termos,"variables"))[-1]
        data<-as.data.frame(as.matrix(gam.data[,at]))
        fit=glm(formul,family=binomial,data=data)
        prob=predict(fit,type='response')
        fit=gamfit(form,gam.data,pts=pts,region=region,h=h,ngrid=ngrid)
        surf.est=fit$g2est$z
list(prob=prob,surf.est=surf.est,h=h,x=fit$g2est$x,y=fit$g2est$y,
        tvalobs=mean(fit$g2^2))
}

