`gamfit` <-
function(form,gam.data,pts,region,h=0,hvals=NA,ngrid=4000){
 formul=formula(form)
 termos<-terms(formul)
 at<-as.character(attr(termos,"variables"))[-1]
 data<-as.data.frame(as.matrix(gam.data[,at]))
 why<-data[,at[1]]
 ny<-nrow(data)
 g2=rep(0,ny)
 fit=glm(formul,family=binomial,data=data)
 g1=predict(fit)
 fhat <- g1 + g2
 phat <- exp(fhat)/(1+exp(fhat))
 w <- phat*(1-phat)
 z <- fhat + (why-phat)/w
  
if(h!=0){
new=waddmod(formul,data,pts,g2=g2,z=z,w=w,hopt=h,hvals=hvals,region=region,sameh=T);old=new
new=waddmod(formul,data,pts,g2=old$g2,z=old$z,w=old$w,hopt=h,hvals=hvals,region=region,sameh=T);old=new
new=waddmod(formul,data,pts,g2=old$g2,z=old$z,w=old$w,hopt=h,hvals=hvals,region=region,sameh=T);old=new
new=waddmod(formul,data,pts,g2=old$g2,z=old$z,w=old$w,hopt=h,hvals=hvals,region=region,sameh=T);old=new
new=waddmod(formul,data,pts,g2=old$g2,z=old$z,w=old$w,hopt=h,hvals=hvals,region=region,sameh=T);old=new
new=waddmod(formul,data,pts,g2=old$g2,z=old$z,w=old$w,hopt=h,hvals=hvals,region=region,ngrid=ngrid,sameh=T)
}
else{
new=waddmod(formul,data,pts,g2=g2,z=z,w=w,hvals=hvals,region=region);old=new
new=waddmod(formul,data,pts,g2=old$g2,z=old$z,w=old$w,hopt=old$h,hvals=hvals,region=region);old=new
new=waddmod(formul,data,pts,g2=old$g2,z=old$z,w=old$w,hopt=old$h,hvals=hvals,region=region);old=new
new=waddmod(formul,data,pts,g2=old$g2,z=old$z,w=old$w,hopt=old$h,hvals=hvals,region=region);old=new
new=waddmod(formul,data,pts,g2=old$g2,z=old$z,w=old$w,hopt=old$h,hvals=hvals,region=region,sameh=T);old=new
new=waddmod(formul,data,pts,g2=old$g2,z=old$z,w=old$w,hopt=old$h,hvals=hvals,region=region,ngrid=ngrid,sameh=T)
}
new
}

